# 代码运行
## 1. 解压源代码
如解决至d:/dev/jsaas_boot目录，如下所示：

![](/uploads/202005/attach_160d9eff3806d6c4.png)

## 2. 运行Idea工具，导入项目，选择源代码目录：

![](/uploads/202005/attach_160d9f0d1f046408.png)

## 3. 设置maven构建环境
![](/uploads/202005/attach_160d9f1dd41f72dc.png)
进入maven环境设置

![](/uploads/202005/attach_160d9f4569f448b0.png)

## 4. 把源代码转为maven项目

![](/uploads/202005/attach_160d9f548888b838.png)

![](/uploads/202005/attach_160d9f692578791c.png)

![](/uploads/202005/attach_160d9f7602384b78.png)
然后一步一步往下即可
![](/uploads/202005/attach_160d9f8b4e798f28.png)
指定JDK
![](/uploads/202005/attach_160d9f95e3ddf234.png)

![](/uploads/202005/attach_160d9fa354d00ee8.png)

## 5. 配置数据库

安装完成mysql后，创建数据库如jsaas_boot,按顺利执行以下脚本：
![](/uploads/202005/attach_160d9fc6d4a8de10.png)

## 6. 修改源代码数据库连接

### mysql 5.7 版本配置
修改src/main/resources/application.yml以下参数配置
```yaml
spring:
  datasource:
    driver-class-name: com.mysql.jdbc.Driver
    url: jdbc:mysql://localhost:3306/jsaas-bootv2?useUnicode=true&characterEncoding=UTF-8&userSSL=false&serverTimezone=GMT%2B8
    username: root
    password: 123456
```
### mysql 8.0 版本配置

mysql 8.0 版本与5.7的版本配置区别主要是在驱动上，需要修改以下两块的配置
1. 修改工程的pom.xml
```xml
        <dependency>
            <groupId>mysql</groupId>
            <artifactId>mysql-connector-java</artifactId>
            <version>8.0.20</version>
        </dependency>

<!--        <dependency>-->
<!--            <groupId>mysql</groupId>-->
<!--            <artifactId>mysql-connector-java</artifactId>-->
<!--            <version>5.1.34</version>-->
<!--        </dependency>-->
```
2. 修改application.yml的driver-class-name为以下：
com.mysql.cj.jdbc.Driver
## 7. 运行maven

clean
compile
build

在IDEA下可双击右边的maven面板上的对应目标，若jar下载顺利，即可正确运行，如下所示：
![](/uploads/202005/attach_160da01f5bf18e3c.png)

## 8. 运行源代码
找到com.redxun.JsaasApplication.java，右键，点击run或debug菜单项，如下：

![](/uploads/202005/attach_160da02de7a701ec.png)

## 9. 若能成功访问，即可访问：

http://localhost:8080/jsaas

初始化用户：admin
密码：1

## 10.FAQ

配置运行参数，配置JVM参数，可解决一些运行的表单设计时中文乱码显示的问题，如下：
![](/uploads/202005/attach_160da07e0beff7d4.png)